require("luci.sys")
require("luci.util")
require("io")
local t,a,e,n
local o=require"nixio.fs"
local i=require"luci.model.uci".cursor()
local h=i:get("AdGuardHome","AdGuardHome","configpath")or"/etc/config/adGuardConfig/AdGuardHome.yaml"
local r=i:get("AdGuardHome","AdGuardHome","binpath")or"/etc/config/adGuardConfig/AdGuardHome"
httpport=i:get("AdGuardHome","AdGuardHome","httpport")or"3000"
t=Map("AdGuardHome","AdGuard Home")
t.description=translate("Free and open source, powerful network-wide ads & trackers blocking DNS server.")
t:section(SimpleSection).template="AdGuardHome/AdGuardHome_status"
a=t:section(TypedSection,"AdGuardHome")
a.anonymous=true
a.addremove=false
e=a:option(Flag,"enabled",translate("Enable"))
e.default=0
e.optional=false
e=a:option(Value,"httpport",translate("Browser management port"))
e.placeholder=3000
e.default=3000
e.datatype="port"
e.optional=false
e.description=translate("<input type=\"button\" style=\"width:210px;border-color:Teal; text-align:center;font-weight:bold;color:Green;\" value=\"AdGuardHome Web:"..httpport.."\" onclick=\"window.open('http://'+window.location.hostname+':"..httpport.."/')\"/>")
local d=i:get("AdGuardHome","AdGuardHome","binmtime")or"0"
local s=""
if not o.access(h)then
s=s.." "..translate("no config")
end
if not o.access(r)then
s=s.." "..translate("no core")
else
local e=i:get("AdGuardHome","AdGuardHome","version")
local t=o.stat(r,"mtime")
if t~=tonumber(d)or e==nil then
local a=luci.sys.exec(r.." -c /dev/null --check-config 2>&1| grep -m 1 -E 'v[0-9.]+' -o")
e=string.sub(a,1,-2)
if e==""then e="core error"end
i:set("AdGuardHome","AdGuardHome","version",e)
i:set("AdGuardHome","AdGuardHome","binmtime",t)
i:save("AdGuardHome")
end
s=e..s
end
e=a:option(Button,"restart",translate("Update"))
e.inputtitle=translate("Update core version")
e.template="AdGuardHome/AdGuardHome_check"
e.showfastconfig=(not o.access(h))
e.description=string.format(translate("core version:").."<strong><font id=\"updateversion\" color=\"green\">%s </font></strong>",s)
local s=luci.sys.exec("awk '/  port:/{printf($2);exit;}' "..h.." 2>nul")
if(s=="")then s="?"end
e=a:option(ListValue,"redirect",s..translate("Redirect"),translate("AdGuardHome redirect mode"))
e.placeholder="none"
e:value("none",translate("none"))
e:value("dnsmasq-upstream",translate("Run as dnsmasq upstream server"))
e:value("redirect",translate("Redirect 53 port to AdGuardHome"))
e:value("exchange",translate("Use port 53 replace dnsmasq"))
e.default="none"
e.optional=true
e=a:option(Value,"binpath",translate("Bin Path"),translate("AdGuardHome Bin path if no bin will auto download"))
e.default="/etc/config/adGuardConfig/AdGuardHome"
e.datatype="string"
e.optional=false
e.rmempty=false
e.validate=function(i,a)
if a==""then return nil end
if o.stat(a,"type")=="dir"then
o.rmdir(a)
end
if o.stat(a,"type")=="dir"then
if(t.message)then
t.message=t.message.."\nerror!bin path is a dir"
else
t.message="error!bin path is a dir"
end
return nil
end
return a
end
e=a:option(ListValue,"upxflag",translate("use upx to compress bin after download"))
e:value("",translate("none"))
e:value("-1",translate("compress faster"))
e:value("-9",translate("compress better"))
e:value("--best",translate("compress best(can be slow for big files)"))
e:value("--brute",translate("try all available compression methods & filters [slow]"))
e:value("--ultra-brute",translate("try even more compression variants [very slow]"))
e.default=""
e.description=translate("bin use less space,but may have compatibility issues")
e.rmempty=true
e=a:option(Value,"configpath",translate("Config Path"),translate("AdGuardHome config path"))
e.default="/etc/config/adGuardConfig/AdGuardHome.yaml"
e.datatype="string"
e.optional=false
e.rmempty=false
e.validate=function(i,a)
if a==nil then return nil end
if o.stat(a,"type")=="dir"then
o.rmdir(a)
end
if o.stat(a,"type")=="dir"then
if t.message then
t.message=t.message.."\nerror!config path is a dir"
else
t.message="error!config path is a dir"
end
return nil
end
return a
end
e=a:option(Value,"workdir",translate("Work dir"),translate("AdGuardHome work dir include rules,audit log and database"))
e.default="/etc/config/adGuardConfig/workspace"
e.datatype="string"
e.optional=false
e.rmempty=false
e.validate=function(i,a)
if a==""then return nil end
if o.stat(a,"type")=="reg"then
if t.message then
t.message=t.message.."\nerror!work dir is a file"
else
t.message="error!work dir is a file"
end
return nil
end
if string.sub(a,-1)=="/"then
return string.sub(a,1,-2)
else
return a
end
end
e=a:option(Value,"logfile",translate("Runtime log file"),translate("AdGuardHome runtime Log file if 'syslog': write to system log;if empty no log"))
e.datatype="string"
e.rmempty=true
e.validate=function(i,a)
if o.stat(a,"type")=="dir"then
o.rmdir(a)
end
if o.stat(a,"type")=="dir"then
if t.message then
t.message=t.message.."\nerror!log file is a dir"
else
t.message="error!log file is a dir"
end
return nil
end
return a
end
e=a:option(Flag,"verbose",translate("Verbose log"))
e.default=0
e.optional=true
local s=luci.sys.call("grep -m 1 -q programadd "..h)
if(s==0)then
s="Added"
else
s="Not added"
end
e=a:option(Button,"gfwdel",translate("Del gfwlist"),translate(s))
e.optional=true
e.inputtitle=translate("Del")
e.write=function()
luci.sys.exec("sh /usr/share/AdGuardHome/gfw2adg.sh del 2>&1")
luci.http.redirect(luci.dispatcher.build_url("admin","services","AdGuardHome"))
end
e=a:option(Button,"gfwadd",translate("Add gfwlist"),translate(s))
e.optional=true
e.inputtitle=translate("Add")
e.write=function()
luci.sys.exec("sh /usr/share/AdGuardHome/gfw2adg.sh 2>&1")
luci.http.redirect(luci.dispatcher.build_url("admin","services","AdGuardHome"))
end
e=a:option(Value,"gfwupstream",translate("Gfwlist upstream dns server"),translate("Gfwlist domain upstream dns service")..translate(s))
e.default="tcp://223.5.5.5"
e.datatype="string"
e.optional=true
e=a:option(Value,"hashpass",translate("Change browser management password"),translate("Press load culculate model and culculate finally save/apply"))
e.default=""
e.datatype="string"
e.template="AdGuardHome/AdGuardHome_chpass"
e.optional=true
e=a:option(MultiValue,"upprotect",translate("Keep files when system upgrade"))
e:value("$binpath",translate("core bin"))
e:value("$configpath",translate("config file"))
e:value("$logfile",translate("log file"))
e:value("$workdir/data/sessions.db",translate("sessions.db"))
e:value("$workdir/data/stats.db",translate("stats.db"))
e:value("$workdir/data/querylog.json",translate("querylog.json"))
e:value("$workdir/data/filters",translate("filters"))
e.widget="checkbox"
e.default=nil
e.optional=true
e=a:option(Flag,"waitonboot",translate("On boot when network ok restart"))
e.default=1
e.optional=true
local s=i:get("AdGuardHome","AdGuardHome","workdir")or"/usr/bin/AdGuardHome"
e=a:option(MultiValue,"backupfile",translate("Backup workdir files when shutdown"))
n=a:option(Value,"backupwdpath",translate("Backup workdir path"))
local h
e:value("filters","filters")
e:value("stats.db","stats.db")
e:value("querylog.json","querylog.json")
e:value("sessions.db","sessions.db")
n:depends("backupfile","filters")
n:depends("backupfile","stats.db")
n:depends("backupfile","querylog.json")
n:depends("backupfile","sessions.db")
for t in o.glob(s.."/data/*")
do
t=o.basename(t)
if t~="filters"and t~="stats.db"and t~="querylog.json"and t~="sessions.db"then
e:value(t,t)
n:depends("backupfile",t)
end
end
e.widget="checkbox"
e.default=nil
e.optional=false
e.description=translate("Will be restore when workdir/data is empty")
n.default="/etc/config/adGuardConfig/workspace"
n.datatype="string"
n.optional=false
n.validate=function(i,a)
if o.stat(a,"type")=="reg"then
if t.message then
t.message=t.message.."\nerror!backup dir is a file"
else
t.message="error!backup dir is a file"
end
return nil
end
if string.sub(a,-1)=="/"then
return string.sub(a,1,-2)
else
return a
end
end
e=a:option(MultiValue,"crontab",translate("Crontab task"),translate("Please change time and args in crontab"))
e:value("autoupdate",translate("Auto update core"))
e:value("cutquerylog",translate("Auto tail querylog"))
e:value("cutruntimelog",translate("Auto tail runtime log"))
e:value("autohost",translate("Auto update ipv6 hosts and restart adh"))
e:value("autogfw",translate("Auto update gfwlist and restart adh"))
e.widget="checkbox"
e.default=nil
e.optional=true
e=a:option(TextValue,"downloadlinks",translate("Download links for update"))
e.optional=false
e.rows=4
e.wrap="soft"
e.cfgvalue=function(t,t)
return o.readfile("/usr/share/AdGuardHome/links.txt")
end
e.write=function(t,t,e)
o.writefile("/usr/share/AdGuardHome/links.txt",e:gsub("\r\n","\n"))
end
o.writefile("/var/run/lucilogpos","0")
function t.on_commit(e)
if(o.access("/var/run/AdGserverdis"))then
io.popen("/etc/init.d/AdGuardHome reload &")
return
end
local e=i:get("AdGuardHome","AdGuardHome","ucitracktest")
if e=="1"then
return
elseif e=="0"then
io.popen("/etc/init.d/AdGuardHome reload &")
else
if(o.access("/var/run/AdGlucitest"))then
i:set("AdGuardHome","AdGuardHome","ucitracktest","0")
io.popen("/etc/init.d/AdGuardHome reload &")
else
o.writefile("/var/run/AdGlucitest","")
if(e=="2")then
i:set("AdGuardHome","AdGuardHome","ucitracktest","1")
else
i:set("AdGuardHome","AdGuardHome","ucitracktest","2")
end
end
i:save("AdGuardHome")
end
end
return t